#include "../header/SM3DTypes.h"
#include "../header/SM3DUtility.h"
#include "../header/SM3DColor.h"
#include "../header/SM3DCamera.h"
#include "../header/SM3DTexture.h"

#include <math.h>
void my_entry(void)
{
	SM3DInit();
	UInt16 pix[4096+4];
		
	#ifndef WIN32
	*(UInt16*)0x4000000=0x15;
 	*(UInt16*)0x4000004=8;
	#endif
	
	{
	smTexture txt;
	//txt.txt=(void*) new UInt16[64*64];
	txt.txt=(void*) pix;
	{
		UInt16 *p=(UInt16 *)txt.txt;
		int t;
		for(t=0; t<(64*64); t++){
			if( (t%16)<8 && ((t/64)%16)<8)
				*(p++)=0x7ff0;
			else
				*(p++)=0;
		}
		txt.dx=64;
		txt.dy=64;
		txt.lx=2;
		txt.ly=2;
		txt.sh=6;
	}
	
	{
#ifndef WIN32
		extern UInt8 text;
#else
		UInt8 text;
#endif
		UInt8 *tx=&text;
		UInt16 *p=(UInt16 *)txt.txt;
		UInt32 t;

		tx=&text;
		p=(UInt16 *)txt.txt;
		for(t=0; t<64*64; t++){
			*(p++)=(*tx)>>3;
			tx++;
		}
	
		tx=&text+4096;
		p=(UInt16 *)txt.txt;
		for(t=0; t<64*64; t++){
			*(p)=*(p) | ((*tx>>3) & 0x1f)<<5;
			p++;
			tx++;
		}

		tx=&text+4096+4096;
		p=(UInt16 *)txt.txt;
		for(t=0; t<64*64; t++){
			*(p)=*(p) | ((*tx>>3) & 0x1f)<<10;
			p++;
			tx++;
		}
	
	}	
	smBuffer buf;
	smCamera c1(0,0,0);
	smPoint32 p,p1;
	smRGB16 cl=0xffff;
	Fl32 ang=0;
	Int32 ang1=0;
	
	smPointC lg0;
	lg0.x=10;
	lg0.y=20;
	lg0.z=0;
	lg0.cl.r=250;
	lg0.cl.g=250;
	lg0.cl.b=250;
	lg0.s=150;
	lg0.t=28;
	set_Light(0,lg0);
	set_NumLight(1);
	
	for(int t=0; t<100; t++){
	
			
			c1.buf=&buf;
			buf.Cls();
			ang+=pi/40;
			ang1+=Ncmp/80;

			//
			// cube demo
			//			
			smPoint32 pcb[8],ptb[8],pob[8],p1,p2;
			Int32 cnt;

			pcb[0]=smPoint32(-10,10,-10); 
			pcb[1]=smPoint32(10,10,-10);
			pcb[2]=smPoint32(10,-10,-10);
			pcb[3]=smPoint32(-10,-10,-10);
			pcb[4]=smPoint32(-10,10,10);
			pcb[5]=smPoint32(10,10,10);
			pcb[6]=smPoint32(10,-10,10);
			pcb[7]=smPoint32(-10,-10,10);

			for(cnt=0; cnt<8; cnt++){
				ptb[cnt]=pcb[cnt];
				ptb[cnt]=ptb[cnt].ruota_yv(smPoint32(0,0,0),(ang1));
				ptb[cnt]=ptb[cnt].ruota_xv(smPoint32(0,0,0),(ang1));
				ptb[cnt]=ptb[cnt].ruota_zv(smPoint32(0,0,0),(ang1));
				ptb[cnt].z+=80;
			}
			
			//
			//	Texture
			//
			{
				UInt16 x,y;
				smRGB16 col;
				for(y=0; y<64 ;y++)
				for(x=0; x<64 ;x++){
					col.cl=*((UInt16*)(txt.txt)+x+64*y);
					buf.smPutPixel(x,y,col);
				}
			}
			//
			//	Dots
			//
/*			{
				Int32 x,y;
				SMErr err=0;
				smPointC pnt,po;
				
				for(y=0; y<100; y+=5)
					for(x=-50; x<50; x+=5){
						pnt.x=x;
						pnt.y=-10+(10*sinv[RadToNcmp(pi*y/100+ang)]*cosv[RadToNcmp(pi*x/100-ang)])>>16;
						pnt.z=y;
						po=c1.TreToDued(pnt,err);
						if(err == SM3DErr_NoErr){
							buf.smPutPixel(80+po.x,64-po.y,0x7fff);
						}
					}
			}
*/			
			//
			// Cube
			//
			{
				smPointC norm;
				smRGB outc;
				smRGB16 outc1,cl;
				pob[0]=ptb[0];
				pob[1]=ptb[1];
				pob[2]=ptb[2];
				pob[3]=ptb[3];
				c1.CalcLightPoly(pob,4);
				c1.smQuad(pob,4,&txt,false);

				pob[0]=ptb[5];
				pob[1]=ptb[4];
				pob[2]=ptb[7];
				pob[3]=ptb[6];
				c1.CalcLightPoly(pob,4);
				c1.smQuad(pob,4,&txt,false);

				pob[0]=ptb[4];
				pob[1]=ptb[5];
				pob[2]=ptb[1];
				pob[3]=ptb[0];
				c1.CalcLightPoly(pob,4);
				c1.smQuad(pob,4,&txt,false);

				pob[0]=ptb[3];
				pob[1]=ptb[2];
				pob[2]=ptb[6];
				pob[3]=ptb[7];
				c1.CalcLightPoly(pob,4);
				c1.smQuad(pob,4,&txt,false);

				pob[0]=ptb[1];
				pob[1]=ptb[5];
				pob[2]=ptb[6];
				pob[3]=ptb[2];
				c1.CalcLightPoly(pob,4);
				c1.smQuad(pob,4,&txt,false);

				pob[0]=ptb[4];
				pob[1]=ptb[0];
				pob[2]=ptb[3];
				pob[3]=ptb[7];
				c1.CalcLightPoly(pob,4);
				c1.smQuad(pob,4,&txt,false);

			}

			buf.Swap();
		}

	}
	
	while(1) 1;
}


